import axios from 'axios'
// import { fetchEventSource } from '@microsoft/fetch-event-source'

export function useChat() {
  const AK = 'wY7bvMpkWeZbDVq9w3EDvpjU'
  const SK = 'XJwpiJWxs5HXkOtbo6tQrvYPZFJAWdAy'

  const messages = ref([])
  const chatId = ref(null)
  const isLoading = ref(false)

  async function post(data) {
    isLoading.value = true
    const res = await axios.post('/api/qianfan/rpc/2.0/ai_custom/v1/wenxinworkshop/chat/eb-instant?access_token=' + (await getAccessToken()), {
      messages: [{ role: 'user', content: data.userChatInput }]
    })
    messages.value.push({ role: 'assistant', content: res.data.result.replaceAll('\n', '<br/>') })
    isLoading.value = false
    // await fetchEventSource('/api/qianfan/rpc/2.0/ai_custom/v1/wenxinworkshop/chat/eb-instant?access_token=' + (await getAccessToken()), {
    //   method: 'POST',
    //   headers: { 'Content-Type': 'application/json' },
    //   body: JSON.stringify({
    //     messages: [{ role: 'user', content: data.userChatInput }],
    //     stream: true
    //   }),
    //   async onopen(response) {
    //     if (response.ok) {
    //       return response
    //     } else {
    //       throw response
    //     }
    //   },
    //   onmessage(res) {
    //     console.log(res.data)
    //     const message = JSON.parse(res.data)
    //     chatId.value = message.chatId
    //     const id = message.id
    //     const messageIndex = messages.value.findIndex(session => session.id === id)
    //     let content = message.result || ''
    //     if (message.result === '\n') content = '<br/>'
    //     if (messageIndex === -1) {
    //       messages.value.push({ id, role: 'bot', content })
    //     } else {
    //       messages.value[messageIndex].content = messages.value[messageIndex].content + content
    //     }
    //     isLoading.value = false
    //   },
    //   onerror(err) {
    //     isLoading.value = false
    //     throw err
    //   }
    // })
  }

  async function getAccessToken() {
    const res = await axios.post('/api/qianfan/oauth/2.0/token?grant_type=client_credentials&client_id=' + AK + '&client_secret=' + SK)
    return res.data.access_token
  }

  return { chatId, messages, post, isLoading }
}
